



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>基于tiny4412的u-boot移植（一）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">基于tiny4412的u-boot移植（一）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 23:24:33 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>作者信息</h1>
<p>作者：彭东林</p>
<p>邮箱：<a href="pengdonglin137@163.com" rel="external nofollow noreferrer">pengdonglin137@163.com</a></p>
<p>QQ: 405728433</p>
<hr />
<h1>平台介绍</h1>
<p>开发环境：win7 64位 + VMware11 + Ubuntu14.04 64位</p>
<p>开发板：tiny4412ADK + S700 + 4GB eMMC + 1G DDR3</p>
<p>工具链：友善之臂提供的 arm-linux-&nbsp; (gcc version 4.5.1)</p>
<p>要移植的u-boot版本：u-boot-2015-10</p>
<p>参考u-boot版本：友善之臂提供的 u-boot-2010-12</p>
<h1>摘要</h1>
<p>本博文简要分析了移植u-boot-2015-12到tiny4412，采用的是spl的启动方式，目前可以做到的是进入u-boot的命令终端，如下图：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/480488/201512/480488-20151227162114390-2099250208.png" /></p>
<p>而且仅仅支持从SD卡启动，以后会慢慢完善。</p>
<h1>移植</h1>
<p>要移植u-boot到tiny4412，首先我们需要对这块板子的<strong>启动方式</strong>、<strong>地址空间</strong>分配有清楚的认识。此外，由于刚开始只需要做到进入u-boot的命令行（如上图），其中至少涉及到了<strong>系统时钟初始化</strong>、<strong>内存初始化</strong>以及<strong>串口初始化</strong>，做到这三点，就为以后的各种工作铺平了道路。</p>
<p>下面是一些参考资料：</p>
<ol><li><a href="http://www.techbulo.com/category/tech/tiny4412/noos/page/2" rel="external nofollow noreferrer">技术部落</a> （这个网站对tiny4412的启动、时钟、串口以及内存初始化进行了详细的讲解）</li>
<li>嵌入式Linux系统开发完全手册_基于4412_上册.pdf （这个文档是韦东山写的，讲的也非常好）</li>
<li>Android_Exynos4412_iROM_Secure_Booting_Guide_Ver.1.00.00.pdf （这篇文档是Samsung的，详细介绍了这款SOC的启动）</li>
<li>SEC_Exynos4412_Users Manual_Ver.1.00.00.pdf （这篇文档也是Samsung的，是exynos4412的用户手册，有两千八百多页，包含了exynos4412的详细信息）</li></ol>
<p>下面我简要说明。</p>
<ul><li><strong>exynos4412的地址空间</strong></li></ul>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/480488/201512/480488-20151227162115890-908272203.png" /></p>
<p>我们需要关注的主要是上面三个。</p>
<p>iROM：这段地址空间对应exynos4412内部固化的一段程序，exynos4412启动的第一条指令就存放在这里。</p>
<p>iRAM：这段地址空间对应的是exynos4412内部的一个存储器，这段存储器的特点是上电就可以用，不用初始化。</p>
<p>DMC0：这段地址空间就是核心板上的DDR3对应的存储空间（我的tiny4412有1GB的DDR3，所以地址空间是0x40000000-0x80000000），上电后需要初始化DRAM控制器才能使用。</p>
<ul><li><strong>exynos4412的启动</strong></li></ul>
<p>可以有几张图：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/480488/201512/480488-20151227162117577-63857677.png" /></p>
<p>图一</p>
<p>图一中，iROM首先运行，然后根据OM的值判断从哪个存储设备加载BL1到iRAM，然后BL1再根据OM的值判断从哪个存储设备加载OS到DRAM中。注意：以tiny4412从sdcard启动为例，iROM固化在SOC内部，BL1是Samsung提供的镜像文件E4412_N.bl1.bin，OS在这里可以认为是BL2，这部分是u-boot代码中编译生成的SPL，BL2是由BL1加载到iRAM中运行的。最后，BL2再根据OM值，从sdcard中将u-boot代码拷贝到DRAM中。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/480488/201512/480488-20151227162118874-1515078140.png" /></p>
<p>图二</p>
<p>图二中，显示了iROM、BL1和BL2的运行地址空间，iRAM的地址空间是0x02020000-0x02060000。由于iROM是只读存储器，所以把iRAM的0x02020000-0x02021400的5KB地址空间分配给iROM用，用于存放iROM的全局变量（ZI/RW，分别存放全局未初始化变量、全局已初始化变量）、局部变量（stack）等等。从0x02021400-0x02023400的8KB地址空间属于BL1，可以认为BL1的第一条指令就存放在0x02021400地址单元。紧接着的0x02023400-0x02027400的16KB地址空间属于BL2，即：BL2的第一条指令存放的地址就是0x02023400，这个值很重要，如果我们的SPL中有&ldquo;非位置无关码&rdquo;，那么就必须将SPL加载到其运行地址处，否则在执行那些非位置无关码的时候会出错，我们知道，SPL这段程序是由BL1负责加载到iRAM的0x02023400地址处运行的，但是BL1是Samsung提供的，并没有源代码，只有二进制镜像，所以在SPL有&ldquo;非位置无关码&rdquo;的时候，必须将SPL的链接地址设置为0x02023400.</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/480488/201512/480488-20151227162119921-1159633239.png" /></p>
<p>图三</p>
<p>图三中是从sdcard启动时，程序在sdcard中的布局。其中sdcard的扇区大小是512B。第0个扇区是保留扇区，第1到第16扇区共8KB的空间存放BL1（也就是：E4412_N.bl1.bin），从第17到第48扇区的16KB空间用于存放BL2（也就是u-boot-spl.bin），之后的扇区可以根据实际需求自己安排。</p>
<p>关于时钟、DRAM、串口的初始化请参考上面列出的参考资料。</p>
<p>有了上面的基础知识，下面开始移植。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8k3w3qj.html">AOS &ndash; 另外一个独特的页面滚动动画库（CSS3）</a>
		</li>
						<li><a href="https://www.batexi.com/a/49ggxwl9.html">MySQL的btree索引和hash索引的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1g0m39.html">MVC系列之二 Model层细解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z54p69.html">很不错的文章---【问底】徐汉彬：亿级Web系统搭建&mdash;&mdash;单机到分布式集群</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yw450q.html">【HDOJ】1542 Atlantis</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k163j79.html">TCP三次握手和http过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn3dnd8.html">UILabel的size根据文字的长短变化</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj5vr38.html">Mac上写C&plus;&plus;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzpgkl8.html">Angular2之管道学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpkxn79.html">【JVM命令系列】jstack</a>
		</li>
						<li><a href="https://www.batexi.com/a/960opj49.html">北大poj- 1013</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlllko6q.html">pip 安装模块时出现error&colon; Microsoft Visual C&plus;&plus; 14&period;0 is required&period; Get it with &amp;quot&semi;Microsoft Visual C&plus;&plus; Build Tools&amp;quot&semi;&colon;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdoz0d9.html">Django路由层</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rd1z58.html">&amp;lt&semi;20180929&amp;gt&semi;任性的甲方</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyx13dq.html">Linux下ftp安装配置及三种用户的验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jw5z0q.html">Wshshell  脚本简单学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyey1mq.html">C&num; 多线程学习系列三之CLR线程池系列之ThreadPool</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk67wn8.html">一、Linux概述 &Tab;二、Linux的安装 &Tab;三、Linux的常用命令（重点）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkdm6x8.html">洛谷P3275 &lbrack;SCOI2011&rsqb;糖果 &lbrack;差分约束系统&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pxv4jq.html">SQLServer 之 聚合函数</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9jm7n5w9.html">百度天气接口api</a>
			</li>
						<li><a href="https://www.batexi.com/a/963n5xn9.html">Selenium之IE浏览器的启动问题及解决</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7e1g2k9.html">史上最全的MonkeyRunner自动化测试从入门到精通（1）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8koz2r6q.html">&num;C&plus;&plus;初学记录&lpar;阶乘&num;递归&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/90254v4q.html">15信号sigaction</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mj4yn08.html">Educational Codeforces Round 55 &lpar;Rated for Div&period; 2&rpar; Solution</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rnlwx4q.html">如何写一个自己的渣渣PHP框架</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pp5eok9.html">VC&plus;&plus;使用FindFirstFile&comma;FindNextFile遍历一个文件夹</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rnlpv4q.html">POJ 2240 Arbitrage（判正环）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnne6pkq.html">创建maven或者Gradle项目的时候GroupId和ArtifactId以及Version是什么意思？</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
